#!/usr/bin/perl

use lib '/usr/sausalito/perl';
use SWUpdate;
use CCE;

my $localedir = '/usr/share/locale';

my $cce = new CCE;
$cce->connectfd();

my $obj = $cce->event_old();

my $vendor = $obj->{vendor};
my $name = $obj->{name};
my $version = $obj->{version};

my @oids = $cce->find('Package', { name => $obj->{name},
				   vendor => $obj->{vendor},
				   version => $obj->{version} } );

# only delete if we're the last object using with this identity
if ($#oids > 0) {
	$cce->bye('SUCCESS');
	exit 0;
}

# delete install directories if they exist.
swupdate_rmunpacked($obj->{location});
if ($vendor and $name and $version) {
    # delete splash stuff
    my $splashdir = swupdate_splashdir($vendor, $name, $version);
    `rm -rf $splashdir`;
    
    # delete locale files
    my $localename = swupdate_localename($vendor, $name, $version);
    `find $localedir -type f -name $localename\* | xargs rm -f`;

    # delete uninstall scripts
    my $scriptdir = swupdate_scriptdir($vendor, $name, $version);
    `rm -rf $scriptdir`;
}
$cce->bye('SUCCESS');
exit 0;
