#!/usr/bin/perl

# Copyright 2000, Cobalt Networks.  All rights reserved.
# $Id: cron.pl,v 1.1 2000/09/22 10:28:51 asun Exp $
# author: mchan@cobalt.com

use lib '/usr/sausalito/perl';
use CCE;
use Sauce::Util;

my $CRON_DAILY_DIR   = "/etc/cron.daily";
my $CRON_WEEKLY_DIR  = "/etc/cron.weekly";
my $CRON_MONTHLY_DIR = "/etc/cron.monthly";
my $CRONFILE         = "SWUpdate";
my $SWUPDATE_BIN     = "/usr/sausalito/sbin/grab_updates.pl -c";
my $SWUPDATE_HDR     = "#!/bin/sh\n# Cobalt Networks SWUpdate (Copyright 2000)";

my $cce = new CCE;

my ($sysId, $SWUpdate_obj, $updateInterval, $cronDir, $success);

#  -------- Main ---------------------
$cce->connectfd(\*STDIN, \*STDOUT);

($sysId) = $cce->find("System");
($success, $SWUpdate_obj) = $cce->get($sysId, "SWUpdate");

$updateInterval = $SWUpdate_obj->{updateInterval};

# delete all previous crontabs here
deleteUpdateCron();

if ($updateInterval eq "Daily") {
  $cronDir = $CRON_DAILY_DIR;
} 
elsif ($updateInterval eq "Weekly") {
  $cronDir = $CRON_WEEKLY_DIR;
} 
elsif ($updateInterval eq "Monthly") {
  $cronDir = $CRON_MONTHLY_DIR;
} # don't account "Never" since that's default

if ($cronDir) {
  scheduleUpdate();
}

$cce->bye("SUCCESS");
exit 0;


sub scheduleUpdate {
  open (UPDATECRON, "> $cronDir/$CRONFILE");
  print UPDATECRON "$SWUPDATE_HDR\n";

  print UPDATECRON "$SWUPDATE_BIN\n";
  close (UPDATECRON);
  
  chmod(0755, "$cronDir/$CRONFILE");
}

sub deleteUpdateCron {
  # delete all previous crontabs here
  unlink 
    "$CRON_DAILY_DIR/$CRONFILE", 
    "$CRON_WEEKLY_DIR/$CRONFILE",
    "$CRON_MONTHLY_DIR/$CRONFILE";
}
